clear    % sequential implementation for CCPP data

data_CCPP=textread('CCPP.txt'); % standardization
data_CCPP_X=data_CCPP(:,1:4);
maxdata=max(data_CCPP_X);
mindata=min(data_CCPP_X);
[N0 d]=size(data_CCPP_X); DATA_st=zeros(N0,d);
for j=1:d
    for i=1:N0
        DATA_st(i,j)=(data_CCPP(i,j)-mindata(j))/(maxdata(j)-mindata(j));
    end
end
data_CCPP_X=DATA_st;


n=9000
Ntest=N0-n
X=data_CCPP_X(1:n,:); X_test=data_CCPP_X(n+1:n+Ntest,:);
y=data_CCPP(1:n,5); y_test=data_CCPP(n+1:n+Ntest,5);
%y=log(data_CCPP(1:n,5)); y_test=log(data_CCPP(n+1:n+Ntest,5));
[n d]=size(X)
m=10*d
nug=1e-8;

load CCPPknots_n9000

GX=[ones(n,1) X]; G_test=[ones(Ntest,1) X_test];
options=optimset('Display', 'none', 'LargeScale', 'off', 'Algorithm', 'sqp');


tic

maxJ=16   % the number of iterations
Theta=[]; Kseq=[];
j=0;
while j<maxJ
    j=j+1
    GA=[ones(m+j-1,1) A]; Ac=setdiff(1:n,I);
    if j==1
        gamma0=y(I); theta0=ones(1,d); 
    else
        gamma0=[gamma0; y(adj)];
    end
    
    
    minLS0=fun_LS(gamma0,A,X,y,theta0);
    dLS=minLS0;
    k=0;
    while dLS>0.001&k<100    %(k can be smaller if the convergence is time-consuming)
        k=k+1
        theta0=fmincon(@(theta)  fun_LS(gamma0,A,X,y,theta), theta0, [], [], [], [], 0.0001*ones(1,d), 150*ones(1,d), [], options);
        RA=corrGaussianmat(A,theta0)+nug*eye(m+j-1); RAX=corrGaussianmat2(A,X,theta0);
        K=RA\GA; H=GA'*(RA\GA)+nug*eye(d+1);
        B=K*(H\GX')+(eye(m+j-1)-K*(H\GA'))*(RA\RAX); B=B';
        gamma0=(B'*B+nug*eye(m+j-1))\B'*y;
        minLS=fun_LS(gamma0,A,X,y,theta0);
        dLS=minLS0-minLS;
        minLS0=minLS;
    end
    gammaE=gamma0; thetaE=theta0
    yE=B*gammaE;    
    GCV_PRO(j)=GCV(B,y,yE)     % GCV value
    R_A_test=corrGaussianmat2(A,X_test,thetaE);
    Bp=K*(H\G_test')+(eye(m+j-1)-K*(H\GA'))*(RA\R_A_test); Bp=Bp';
    y_pre=Bp*gammaE;
    Test_Er_PRO(j)=mean((y_test-y_pre).^2)    % test error
    
    res=abs(yE-y); ress=res(Ac);
    [aa j0]=max(ress);
    adj=Ac(j0); I=[I, adj]; A=X(I,:);    
    
    Theta=[Theta; thetaE]; Kseq=[Kseq, k];
end
GCV_PRO
Test_Er_PRO

T_PRO=toc