function z=fun_LS(gamma,A,X,y,theta)  
% input: the GP reconstruction is based on (A, gamma) with kernel parameter theta
% output: z is LS of (X,y)

[n d]=size(X); m=length(A); nug=1e-8;

GA=[ones(m,1) A]; GX=[ones(n,1) X];
RA=corrGaussianmat(A,theta)+nug*eye(m); RAX=corrGaussianmat2(A,X,theta);
K=RA\GA; H=GA'*(RA\GA)+nug*eye(d+1);
B=K*(H\GX')+(eye(m)-K*(H\GA'))*(RA\RAX); B=B';
z=mean((y-B*gamma).^2);